//	T[{SG-90䃉Cu
//	wt]xH쎺	http://jsdiy.webcrow.jp
//	2019/04

/*	PWM̃pXƊpx̊֌W

	<-----> 0.5`2.4ms
	:     :
	+-----+         +-----+
 ---+     +---------+     +---
    :               :
	<----- 20ms ---->
	
	ET[{̎́Av[_0xAv[_180xB
	EpXԂ20ms(50Hz)AHi 0.5`1.45`2.4ms  -90`0`+90xi0`90`180xƂjB
		f[^V[gɂĂ 1.0`1.5`2.0ms  -60`0`+60x ƂB
	ẼCuɂl̖ڈ́A
		0x:	0.50ms +-0.1msx
		90x:	1.20ms +-0.1msx
		180x:	2.00ms +-0.1msx
*/
/*	̃Cuł͕̃T[{L̂悤ɐ䂷
		rv𗘗pĊ荞݂|A̓xɃT[{1Ԃɐ䂷B

		   <----------- 20ms ------------>
		   :                             :
		   +-----+                       +-----+
T[{1	---+     +-----------------------+     +----------------------
		         :
		         +---+                         +---+
T[{2	---------+   +-------------------------+   +------------------
		             :
		             +-------+                     +-------+
T[{3	-------------+       +---------------------+       +----------
		   :                 :           :
		   <---- HiTime ----> <- LoTime ->
*/
/*	CTCɂ4msɊ荞(250Hz)ꍇ̔rĺA
	f_oc = f_clk_io / (2 * N * (1 + OCR))	f_clk_io:VXeNbN, N:l
	250Hz = 8MHz / (2 * N * (1 + OCR))
	OCR + 1 = 8MHz / (2 * N * 250Hz) = 16000 / N ,N=64
	OCR = 250 - 1 = 249
	
	20ms(50Hz)
	OCR + 1 = 8MHz / (2 * N * 50Hz) = 80000 / N ,N=1024
	OCR = 78.125 - 1 = 77

	15ms(66Hz)
	OCR + 1 = 8MHz / (2 * N * 66Hz) = 60000 / N ,N=256
	OCR = 234.375 - 1 = 233

	10ms(100Hz)
	OCR + 1 = 8MHz / (2 * N * 100Hz) = 40000 / N ,N=256
	OCR = 156.25 - 1 = 155

	6ms(166Hz)
	OCR + 1 = 8MHz / (2 * N * 166Hz) = 24000 / N ,N=256
	OCR = 93.75 - 1 = 93

	5ms(200Hz)
	OCR + 1 = 8MHz / (2 * N * 200Hz) = 20000 / N ,N=256
	OCR = 78.125 - 1 = 77
	
	3.3ms(300Hz)
	OCR + 1 = 8MHz / (2 * N * 300Hz) = 13333.3 / N ,N=64
	OCR = 208.3 - 1 = 207

	3ms(333Hz)
	OCR + 1 = 8MHz / (2 * N * 333Hz) = 12000 / N ,N=64
	OCR = 187.5 - 1 = 186
*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "sg90lib.h"

#define	NULL	((void*)0)

//SG-90̓쑬x 0.1s/60xȂ̂ŁAő180x𓮂Ԃ (0.1s/60x)*180x=0.3s=300ms
//pXԂ20msȂ̂ŁAőŕKvȃpX񐔂 300ms/20ms=15
#define	PULSE_COUNT	15
#define	PULSE_PERIOD_MSEC	20.0	//ms

//|[g
#define	PortHi(bv)	(SG90_PORT |= (bv))
#define	PortLo(bv)	(SG90_PORT &= ~(bv))

//T[{\̔z
#define SERVO_COUNT_MAX	6	//\ȍő
static	TServo*	servoList[SERVO_COUNT_MAX] = { NULL };

#if _USE_ASYNC_VER
static	uint8_t	servoIndex = 0;
#endif

#if _USE_SYNC_VER
static	float	pulseLoTime;	//pXLo̎
#endif

//vg^Cv錾
static	void	SetPulseHiTime(TServo* servo, float degree);
static	void	fdelay_ms(float msec);
#if _USE_ASYNC_VER
static	void	OutputPulseHiTime(void);
#endif
#if _USE_SYNC_VER
static	void	Sync_OutputPulseHiTime(void);
static	void	Sync_OutputPulseLoTime(void);
#endif

#if _USE_ASYNC_VER
//rv荞
ISR(TIMER0_COMPA_vect)
{
	OutputPulseHiTime();
}
#endif

//
//	bvUsePorts:	T[{ڑsQBF(1<<PORT2)|(1<<PORT3)
void	SG90_Init(uint8_t bvUsePorts)
{
    SG90_DDR |= bvUsePorts;
	PortLo(bvUsePorts);
	
#if _USE_ASYNC_VER
	//8bit^C}[EJE^[ݒ肷
	//WGM02,01,00 = 010:rv
	//CS02,01,00 = 000:^C}[~, 001:Ȃ, 010:8, 011:64, 100:256, 101:1024,i110:~[, 111:㏸[j
	/*	20ms
	TCCR0A	= (1<<WGM01)|(0<<WGM00);
	TCCR0B	= (0<<WGM02)|(0b101<<CS00);	//1024
	OCR0A	= 77;	//rl
	TIMSK0	|= (1<<OCIE0A);
	//*/
	/*	15ms
	TCCR0A	= (1<<WGM01)|(0<<WGM00);
	TCCR0B	= (0<<WGM02)|(0b100<<CS00);	//256
	OCR0A	= 233;	//rl
	TIMSK0	|= (1<<OCIE0A);
	//*/
	/*	10ms
	TCCR0A	= (1<<WGM01)|(0<<WGM00);
	TCCR0B	= (0<<WGM02)|(0b100<<CS00);	//256
	OCR0A	= 155;	//rl
	TIMSK0	|= (1<<OCIE0A);
	//*/
	/*	6ms
	TCCR0A	= (1<<WGM01)|(0<<WGM00);
	TCCR0B	= (0<<WGM02)|(0b100<<CS00);	//256
	OCR0A	= 93;	//rl
	TIMSK0	|= (1<<OCIE0A);
	//*/
	/*	5ms
	TCCR0A	= (1<<WGM01)|(0<<WGM00);
	TCCR0B	= (0<<WGM02)|(0b100<<CS00);	//256
	OCR0A	= 77;	//rl
	TIMSK0	|= (1<<OCIE0A);
	//*/
	/*	4ms
	TCCR0A	= (1<<WGM01)|(0<<WGM00);
	TCCR0B	= (0<<WGM02)|(0b011<<CS00);	//64
	OCR0A	= 249;	//rl
	TIMSK0	|= (1<<OCIE0A);
	//*/
	//*	3.3ms
	TCCR0A	= (1<<WGM01)|(0<<WGM00);
	TCCR0B	= (0<<WGM02)|(0b011<<CS00);	//64
	OCR0A	= 207;	//rl
	TIMSK0	|= (1<<OCIE0A);
	//*/
	/*	3ms
	TCCR0A	= (1<<WGM01)|(0<<WGM00);
	TCCR0B	= (0<<WGM02)|(0b011<<CS00);	//64
	OCR0A	= 186;	//rl
	TIMSK0	|= (1<<OCIE0A);
	//*/
	
	//荞݋
	sei();
#endif
}

//T[{\̂
void	SG90_InitServo(TServo* servo, uint8_t port, float deg0ms, float deg180ms)
{
	servo->bvPort = (1 << port);
	servo->deg0ms = deg0ms;
	servo->deg180ms = deg180ms;
	servo->hiTime = (deg0ms + deg180ms) / 2;	//90x
	servo->pulseCount = 0;
	servo->isSync = 0;
	
	for (uint8_t i = 0; i < SERVO_COUNT_MAX; i++)
	{
		if (servoList[i] == NULL || servoList[i]->bvPort == servo->bvPort)
		{
			servoList[i] = servo;
			break;
		}
	}
}
//
#if _USE_SYNC_VER
void	SG90_InitServoSync(TServo* servo, uint8_t port, float deg0ms, float deg180ms)
{
	SG90_InitServo(servo, port, deg0ms, deg180ms);
	servo->isSync = 1;
}
#endif

//T[{pxw肳Ă1Xebvȏ㓮
//E񓯊̏ꍇApxw蒼͂܂oĂȂ\B̏ԂoB
//EړI̊px܂œIԂtrueԂB
uint8_t	SG90_IsMoving(TServo* servo)
{
	return (0 < servo->pulseCount);
}

//T[{wpx𓮂I
//ESG-90͍ő180x15Xebvňړ\ƂŁAړƂoB
uint8_t	SG90_IsMoved(TServo* servo)
{
	return (servo->pulseCount == PULSE_COUNT);
}

//pxɉpXHiԂT[{\̂ɃZbg
static	void	SetPulseHiTime(TServo* servo, float degree)
{
	float prevHiTime = servo->hiTime;
	servo->hiTime = servo->deg0ms + (servo->deg180ms - servo->deg0ms) * (degree / 180);
	servo->hiTime *= 0.85;	//l
	
	if (prevHiTime != servo->hiTime) { servo->pulseCount = 0; }
}

//_delay_ms()float
static	void	fdelay_ms(float msec)
{
	for (uint16_t i = 0; i < (uint16_t)(msec * 100); i++) { _delay_us(10); }
}

#if _USE_ASYNC_VER
//y񓯊zT[{Ɋpxw肵Aɓ
void	SG90_Degree(TServo* servo, float degree)
{
	SetPulseHiTime(servo, degree);
}

//y񓯊zT[{ɃpXHio͂
//E荞݂ɂԊuŌĂяoB
static	void	OutputPulseHiTime(void)
{
	TServo* servo = servoList[servoIndex];
	if (servo != NULL && !servo->isSync)
	{
		PortHi(servo->bvPort);
		fdelay_ms(servo->hiTime);
		PortLo(servo->bvPort);
		
		if (servo->pulseCount < PULSE_COUNT) { servo->pulseCount++; }
	}
	
	if (++servoIndex == SERVO_COUNT_MAX) { servoIndex = 0; }
	
	//TCNT0 = 0;	//OCF0Bp链邱ƂlATCNT0ɃZbgȂ
	TIFR0 |= (1<<OCF0A);	//荞ݒɔAg̊荞݃tOi荞ݎԓɏԂɍĂȂƂƁcj
}
#endif

#if _USE_SYNC_VER
//yzT[{Ɋpxw肷i܂Ȃj
//	degree:	0.0`180.0x
void	SG90_SetDegree(TServo* servo, float degree)
{
	SetPulseHiTime(servo, degree);
	
	//pXLoԂZo
	pulseLoTime = PULSE_PERIOD_MSEC;
	for (uint8_t sv = 0; sv < SERVO_COUNT_MAX; sv++)
	{
		TServo* servo = servoList[sv];
		if (servo == NULL || !servo->isSync) { continue; }
		if (servo->hiTime < pulseLoTime) { pulseLoTime -= servo->hiTime; }
	}
}

//yzT[{𓮂iẘpx܂œj
//EgF	SetDegree(sv1), SetDegree(sv2), ... and Run()
void	SG90_Run(void)
{
	for (uint8_t i = 0; i < PULSE_COUNT; i++)
	{
		SG90_Step();
	}
}

//yzT[{𓮂i1pXj
//EgF	SetDegree(sv1), SetDegree(sv2), ... and Step(), Step(), Step(), ...
//EẘpxɓBԂł̊֐ĂяoĂ\ȂiT[{̐ȂjB
void	SG90_Step(void)
{
	Sync_OutputPulseHiTime();
	Sync_OutputPulseLoTime();
}

//yzT[{ɃpXHio͂
static	void	Sync_OutputPulseHiTime(void)
{
	for (uint8_t sv = 0; sv < SERVO_COUNT_MAX; sv++)
	{
		TServo* servo = servoList[sv];
		if (servo == NULL || !servo->isSync) { continue; }
		
		PortHi(servo->bvPort);
		fdelay_ms(servo->hiTime);
		PortLo(servo->bvPort);
		
		if (servo->pulseCount < PULSE_COUNT) { servo->pulseCount++; }
	}
}

//yzT[{ɃpXLoo͂
static	void	Sync_OutputPulseLoTime(void)
{
	fdelay_ms(pulseLoTime);
}
#endif
